## libsmb2 6.2%2Bdfsg

=== lib/CMakeLists.txt ===
if(GSSAPI_FOUND OR LIBKRB5_FOUND)
  set(KRB5_SOURCE krb5-wrapper.c)
endif()

if(ESP_PLATFORM)
  set(COMPONENT_SRCS
    aes.c
    aes128ccm.c
    alloc.c
    asn1-ber.c
    compat.c
    dcerpc.c
    dcerpc-lsa.c
    dcerpc-srvsvc.c
    errors.c
    init.c
    hmac.c
    hmac-md5.c
    ${KRB5_SOURCE}
    libsmb2.c
    md4c.c
    md5.c
    ntlmssp.c
    pdu.c
    sha1.c
    sha224-256.c
    sha384-512.c
    smb2-cmd-close.c
    smb2-cmd-create.c
    smb2-cmd-echo.c
    smb2-cmd-error.c
    smb2-cmd-flush.c
    smb2-cmd-ioctl.c
    smb2-cmd-lock.c
    smb2-cmd-logoff.c
    smb2-cmd-negotiate.c
    smb2-cmd-notify-change.c
    smb2-cmd-oplock-break.c
    smb2-cmd-query-directory.c
    smb2-cmd-query-info.c
    smb2-cmd-read.c
    smb2-cmd-session-setup.c
    smb2-cmd-set-info.c
    smb2-cmd-tree-connect.c
    smb2-cmd-tree-disconnect.c
    smb2-cmd-write.c
    smb2-data-file-info.c
    smb2-data-filesystem-info.c
    smb2-data-security-descriptor.c
    smb2-data-reparse-point.c
    smb2-share-enum.c
    smb3-seal.c
    smb2-signing.c
    socket.c
    spnego-wrapper.c
    sync.c
    timestamps.c
    unicode.c
    usha.c
  )

  set(COMPONENT_NAME ".")

  register_component()

elseif(IOP AND BUILD_IRX)
  set(SOURCES
            ps2/smb2_fio.c
            ps2/smb2man.c
            ps2/imports.c
            aes.c
            aes128ccm.c
            alloc.c
            asn1-ber.c
            compat.c
            dcerpc.c
            dcerpc-lsa.c
            dcerpc-srvsvc.c
            errors.c
            hmac.c
            hmac-md5.c
            init.c
            ${KRB5_SOURCE}
            libsmb2.c
            md4c.c
            md5.c
            ntlmssp.c
            pdu.c
            sha1.c
            sha224-256.c
            sha384-512.c
            smb2-cmd-close.c
            smb2-cmd-create.c
            smb2-cmd-echo.c
            smb2-cmd-error.c
            smb2-cmd-flush.c
            smb2-cmd-ioctl.c
            smb2-cmd-lock.c
            smb2-cmd-logoff.c
            smb2-cmd-negotiate.c
            smb2-cmd-notify-change.c
            smb2-cmd-oplock-break.c
            smb2-cmd-query-directory.c
            smb2-cmd-query-info.c
            smb2-cmd-read.c
            smb2-cmd-session-setup.c
            smb2-cmd-set-info.c
            smb2-cmd-tree-connect.c
            smb2-cmd-tree-disconnect.c
            smb2-cmd-write.c
            smb2-data-file-info.c
            smb2-data-filesystem-info.c
            smb2-data-security-descriptor.c
            smb2-data-reparse-point.c
            smb2-share-enum.c
            smb3-seal.c
            smb2-signing.c
            socket.c
            spnego-wrapper.c
            sync.c
            timestamps.c
            unicode.c
            usha.c)

BUILD_IOP_IMPORTS(${CMAKE_CURRENT_SOURCE_DIR}/ps2/imports.c ${CMAKE_CURRENT_SOURCE_DIR}/ps2/imports.lst)

else()
  set(SOURCES aes.c
            aes128ccm.c
            alloc.c
            asn1-ber.c
            compat.c
            dcerpc.c
            dcerpc-lsa.c
            dcerpc-srvsvc.c
            errors.c
            hmac.c
            hmac-md5.c
            init.c
            ${KRB5_SOURCE}
            libsmb2.c
            md4c.c
            md5.c
            ntlmssp.c
            pdu.c
            sha1.c
            sha224-256.c
            sha384-512.c
            smb2-cmd-close.c
            smb2-cmd-create.c
            smb2-cmd-echo.c
            smb2-cmd-error.c
            smb2-cmd-flush.c
            smb2-cmd-ioctl.c
            smb2-cmd-lock.c
            smb2-cmd-logoff.c
            smb2-cmd-negotiate.c
            smb2-cmd-notify-change.c
            smb2-cmd-oplock-break.c
            smb2-cmd-query-directory.c
            smb2-cmd-query-info.c
            smb2-cmd-read.c
            smb2-cmd-session-setup.c
            smb2-cmd-set-info.c
            smb2-cmd-tree-connect.c
            smb2-cmd-tree-disconnect.c
            smb2-cmd-write.c
            smb2-data-file-info.c
            smb2-data-filesystem-info.c
            smb2-data-security-descriptor.c
            smb2-data-reparse-point.c
            smb2-share-enum.c
            smb3-seal.c
            smb2-signing.c
            socket.c
            spnego-wrapper.c
            sync.c
            timestamps.c
            unicode.c
            usha.c)
endif()

if(NOT ESP_PLATFORM)
set(INCLUDE_PATH ../include)
set(SMB2_INCLUDE "${INCLUDE_PATH}/smb2")
set(HEADERS
    ${SMB2_INCLUDE}/libsmb2-dcerpc-lsa.h
    ${SMB2_INCLUDE}/libsmb2-dcerpc-srvsvc.h
    ${SMB2_INCLUDE}/libsmb2-dcerpc.h
    ${SMB2_INCLUDE}/libsmb2-raw.h
    ${SMB2_INCLUDE}/libsmb2.h
    ${SMB2_INCLUDE}/smb2-errors.h
    ${SMB2_INCLUDE}/smb2.h)

if(EE AND PS2RPC)
add_library(smb2_rpc ${SOURCES} ${HEADERS})
target_link_libraries(smb2_rpc PUBLIC ${core_DEPENDS} ${CORE_LIBRARIES})
target_include_directories(smb2_rpc PUBLIC ${INCLUDE_PATH})
set_target_properties(smb2_rpc PROPERTIES
                           VERSION ${PROJECT_VERSION}
                           SOVERSION ${SOVERSION})
elseif(IOP AND BUILD_IRX)
add_executable(smb2man.irx ${SOURCES})
target_link_libraries(smb2man.irx
        PRIVATE
        gcc)
set_target_properties(smb2man.irx PROPERTIES
        VERSION ${PROJECT_VERSION}
        SOVERSION ${SOVERSION})        
add_custom_command(TARGET smb2man.irx POST_BUILD COMMAND md5sum ARGS smb2man.irx)
elseif(PICO_BOARD)
add_library(libsmb2 STATIC ${SOURCES})
else()
add_library(smb2 ${SOURCES} ${HEADERS})
target_link_libraries(smb2 PUBLIC ${core_DEPENDS} ${CORE_LIBRARIES})
target_include_directories(smb2 PUBLIC ${INCLUDE_PATH})
set_target_properties(smb2 PROPERTIES
                           VERSION ${PROJECT_VERSION}
                           SOVERSION ${SOVERSION})
endif()
endif()

if(NOT MSVC)
  add_definitions("-D_U_=__attribute__((unused))")
else()
  add_definitions("-D_U_=")
  if(CMAKE_SYSTEM_NAME STREQUAL WindowsStore)
    add_definitions("-D_MSC_UWP")
  endif()
endif()

if(NOT PICO_BOARD OR NOT ESP_PLATFORM)
if(EE AND PS2RPC)
install(TARGETS smb2_rpc EXPORT smb2_rpc
                     RUNTIME DESTINATION bin
                     ARCHIVE DESTINATION lib${LIB_SUFFIX}
                     LIBRARY DESTINATION lib${LIB_SUFFIX})
elseif(IOP AND BUILD_IRX)
install(FILES ps2/ps2smb2.h
DESTINATION ${PS2SDK}/common/include)
install(TARGETS smb2man.irx EXPORT smb2man.irx
                            RUNTIME DESTINATION ${PS2SDK}/ports_iop/irx
                            ARCHIVE DESTINATION smb2man.irx
                            LIBRARY DESTINATION smb2man.irx)
else()
install(TARGETS smb2 EXPORT smb2
                     RUNTIME DESTINATION bin
                     ARCHIVE DESTINATION lib${LIB_SUFFIX}
                     LIBRARY DESTINATION lib${LIB_SUFFIX})
endif()
endif()

=== examples/picow/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.24)

# Some user configuration needed below

# Get the Pico SDK from https://github.com/raspberrypi/pico-sdk.git tested on TAG 1.4.0
# Get FreeRTOS from https://github.com/FreeRTOS/FreeRTOS-Kernel.git tested on TAG V10.5.0
# Replace the /path/to's below with appropriate paths
# Something like /home/me/dve/github/pico_sdk, but wherever you put the pico-sdk or freertos-kernel
set(PICO_SDK_PATH /path/to/pick-sdk) 
set(FREERTOS_KERNEL_PATH /path/to/freertos-kernel)
set(LIBSMB2_PATH ${CMAKE_CURRENT_LIST_DIR}/../..)

# Replace with the name of your WiFi (SSID) and the password to join that WiFi
set(WIFI_SSID ssid_name)
set(WIFI_PASSWORD wifi_name)

# Put in the URL of the server/share you want to see the directory of
set(SMB2_URL smb://myserver.lan/myshare)

# No other configuration needed, below this
# Name the project and prepare it to be a pico_w project, using FreeRTOS and lwip
set(PROJECT_NAME libsmb2-picow-ls)
set(PICO_BOARD pico_w)
include(${PICO_SDK_PATH}/pico_sdk_init.cmake)
include(${FREERTOS_KERNEL_PATH}/portable/ThirdParty/GCC/RP2040/FreeRTOS_Kernel_import.cmake)
project(${PROJECT_NAME} C CXX ASM)
pico_sdk_init()

# Add a couple of definitions that all projects/libraries can/should use
add_definitions(-DPICO_PLATFORM=${PICO_PLATFORM})
add_definitions(-DHAVE_CONFIG_H)


# Build libsmb2 as a library
add_subdirectory(${LIBSMB2_PATH} libsmb2)

# The example
set(PROJECT_NAME smb2-ls-sync)
project(${PROJECT_NAME} C CXX ASM)

# Application, including in the FreeRTOS-Kernel
add_executable(${PROJECT_NAME} main.cpp)

# Build the app
include_directories(
        ${CMAKE_CURRENT_LIST_DIR}
        ${FREERTOS_KERNEL_PATH}/include
        ${LIBSMB2_PATH}/include
        ${LIBSMB2_PATH}/include/smb2
        ${LIBSMB2_PATH}/include/picow
)

pico_enable_stdio_usb(${PROJECT_NAME} 1)
pico_enable_stdio_uart(${PROJECT_NAME} 0)
pico_enable_stdio_semihosting(${PROJECT_NAME} ENABLED)

target_compile_definitions(${PROJECT_NAME} PRIVATE
        WIFI_SSID=\"${WIFI_SSID}\"
        WIFI_PASSWORD=\"${WIFI_PASSWORD}\"
        SMB2_URL=\"${SMB2_URL}\"
        NO_SYS=0            # don't want NO_SYS (generally this would be in your lwipopts.h)
)

target_link_libraries(${PROJECT_NAME}
        pico_cyw43_arch_lwip_sys_freertos
        FreeRTOS-Kernel
        pico_stdlib
        libsmb2
        FreeRTOS-Kernel-Heap4
)

pico_add_extra_outputs(${PROJECT_NAME})

## libsmb2 6.2+dfsg

=== CMakeLists.txt ===
if(NOT ESP_PLATFORM)
  
  if(CMAKE_SYSTEM_NAME MATCHES NintendoSwitch OR CMAKE_SYSTEM_NAME MATCHES Nintendo3DS OR CMAKE_SYSTEM_NAME MATCHES Dreamcast OR CMAKE_SYSTEM_NAME MATCHES NintendoGameCube OR CMAKE_SYSTEM_NAME MATCHES NintendoDS OR CMAKE_SYSTEM_NAME MATCHES NintendoWii OR CMAKE_SYSTEM_NAME MATCHES CafeOS)
    cmake_minimum_required(VERSION 3.13)
  elseif(VITA)
    cmake_minimum_required(VERSION 3.2)  
  elseif(PICO_BOARD)
    cmake_minimum_required(VERSION 3.12)
    message(STATUS "Configuring libsmb2 for ${PICO_BOARD}")
  else()
    cmake_minimum_required(VERSION 3.5)
  endif()

  if(NOT IOP AND BUILD_IRX)
    project(smb2man
            LANGUAGES C
            VERSION 2.3.0
    )
    set(VERSION 2.3.0)    
    set(PACKAGE "smb2man")
    set(PACKAGE_BUGREPORT "ronniesahlberg@gmail.com or andregui17@outlook.com")
    set(PACKAGE_NAME "smb2man")
    set(PACKAGE_VERSION "${VERSION}")
    set(PACKAGE_STRING "${PACKAGE_NAME} ${PACKAGE_VERSION}")
    set(PACKAGE_TARNAME "${PACKAGE}")
    set(PACKAGE_URL "https://github.com/sahlberg/libsmb2")
  elseif(PICO_BOARD)
    project(libsmb2 C CXX ASM)
  else()
    project(libsmb2
            LANGUAGES C
            VERSION 6.1.0
    )  
    set(VERSION 6.1.0)
    set(PACKAGE "libsmb2")
    set(PACKAGE_BUGREPORT "ronniesahlberg@gmail.com")
    set(PACKAGE_NAME "libsmb2")
    set(PACKAGE_VERSION "${VERSION}")
    set(PACKAGE_STRING "${PACKAGE_NAME} ${PACKAGE_VERSION}")
    set(PACKAGE_TARNAME "${PACKAGE}")
    set(PACKAGE_URL "https://github.com/sahlberg/libsmb2")
  endif()
  configure_file(libsmb2.pc.in libsmb2.pc @ONLY)
endif()

  if(NOT ESP_PLATFORM)
    set(SOVERSION 1 CACHE STRING "" FORCE)
    if(NOT IOP AND NOT BUILD_IRX)
      set(INSTALL_LIB_DIR "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}" CACHE PATH "Installation directory for libraries")
      set(INSTALL_INC_DIR "${CMAKE_INSTALL_PREFIX}/include" CACHE PATH "Installation directory for headers")
      set(INSTALL_PKGCONFIG_DIR "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}/pkgconfig" CACHE PATH "Installation directory for pkgconfig (.pc) files")
      set(INSTALL_CMAKE_DIR "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}/cmake/libsmb2" CACHE PATH "Installation directory for cmake (.cmake) files")
    endif()
    if(CMAKE_SYSTEM_NAME MATCHES NintendoSwitch OR CMAKE_SYSTEM_NAME MATCHES Nintendo3DS OR PS4 OR PS2 OR VITA OR CMAKE_SYSTEM_NAME MATCHES Dreamcast OR CMAKE_SYSTEM_NAME MATCHES NintendoGameCube OR CMAKE_SYSTEM_NAME MATCHES NintendoDS OR CMAKE_SYSTEM_NAME MATCHES NintendoWii OR CMAKE_SYSTEM_NAME MATCHES CafeOS)
      option(BUILD_SHARED_LIBS "Build shared libraries" OFF)  
    else()
      option(BUILD_SHARED_LIBS "Build shared libraries" ON)
    endif()
      option(ENABLE_EXAMPLES "Build example programs" OFF)
      option(ENABLE_LIBKRB5 "Enable libkrb5 support" ON)
      option(ENABLE_GSSAPI "Enable gssapi support" ON)
      list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake/Modules)
  endif()

  if(CMAKE_SYSTEM_NAME MATCHES Linux)
    if (ENABLE_LIBKRB5)
      find_package(LibKrb5)
    endif()
  elseif(IOS)
    if (ENABLE_GSSAPI)
      find_package(GSSAPI)  
    endif()
  endif()

  if(NOT ESP_PLATFORM)
      include(cmake/ConfigureChecks.cmake)
  endif()

  if(PICO_BOARD)
      include_directories(libsmb2 STATIC
            ${PICO_SDK_PATH}/lib/lwip/src/include
            ${PICO_SDK_PATH}/src/rp2_common/pico_lwip/include
            lib
            include
            include/smb2
            include/picow
    )
    elseif(ESP_PLATFORM)
      set(COMPONENT_ADD_INCLUDEDIRS
      "lib"
      include
      include/smb2
      include/esp
     )
    else()
      include_directories(${CMAKE_CURRENT_BINARY_DIR}
                        include
                        include/smb2
      )
    endif()
    
    if(CMAKE_SYSTEM_NAME MATCHES Linux)
      if (ENABLE_LIBKRB5)
        set(core_DEPENDS ${LIBKRB5_LIBRARY} CACHE STRING "" FORCE)  
      endif()
    elseif(IOS)
      if (ENABLE_GSSAPI)
        set(core_DEPENDS ${GSSAPI_LIBRARIES} CACHE STRING "" FORCE)   
      endif()
    endif()

    if(MSVC AND BUILD_SHARED_LIBS)
      # If we are building dll with msvc, then generate a def file according to the syms file
      set(SYMS_FILE_PATH "${PROJECT_SOURCE_DIR}/lib/libsmb2.syms")
      set(DEF_FILE_PATH "${PROJECT_BINARY_DIR}/lib/libsmb2.def")
      file(READ ${SYMS_FILE_PATH} EXPORT_SYMBOLS)
      file(WRITE ${DEF_FILE_PATH} "LIBRARY smb2\nEXPORTS\n\n${EXPORT_SYMBOLS}")
      # Pass def file to the linker
      set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} /DEF:${DEF_FILE_PATH}")
    endif()

    if(CMAKE_SYSTEM_NAME MATCHES Windows)
      list(APPEND CORE_LIBRARIES ws2_32.lib)
      add_definitions(-DWIN32_LEAN_AND_MEAN -D_CRT_SECURE_NO_WARNINGS -DHAVE_LINGER -DNEED_GETLOGIN_R -DNEED_GETPID -DNEED_RANDOM -DNEED_SRANDOM)
    elseif(CMAKE_SYSTEM_NAME MATCHES NintendoSwitch)
      add_definitions(-DARM11 -DSWITCH -D__SWITCH__ -DNEED_READV -DNEED_WRITEV -DNEED_GETLOGIN_R)
      set(ARCH "-march=armv8-a -mtp=soft -fPIE")
      set(CMAKE_C_FLAGS "-g -Wall -O2 -ffast-math ${ARCH}")
      set(CMAKE_C_FLAGS "-Wno-unused-variable")
      set(CMAKE_CXX_FLAGS "${CMAKE_C_FLAGS} -fno-rtti -std=gnu11")
      set(CMAKE_C_LDFLAGS "${CMAKE_C_FLAGS} -specs=switch.specs -g ${ARCH} -Wl,-Map,$(notdir $*.map)")
      add_compile_options("${CMAKE_C_FLAGS} ${CMAKE_LDFLAGS}")
    elseif(CMAKE_SYSTEM_NAME MATCHES Nintendo3DS)
      add_definitions(-DARM11 -D_3DS -D__3DS__ -DNEED_READV -DNEED_WRITEV -DNEED_GETLOGIN_R)
      set(ARCH "-march=armv6k -mfloat-abi=hard -mtune=mpcore -mtp=soft -fPIE")
      set(CMAKE_C_FLAGS "-Wno-unused-variable -g -Wall -O2 -mword-relocations -fomit-frame-pointer -ffast-math ${ARCH}")
      set(CMAKE_CXX_FLAGS "${CMAKE_C_FLAGS} -fno-rtti -fno-exceptions -std=gnu11")
      set(CMAKE_C_LDFLAGS "${CMAKE_C_FLAGS} -specs=3dsx.specs -g ${ARCH} -Wl,-Map,$(notdir $*.map)")
      add_compile_options("${CMAKE_C_FLAGS} ${CMAKE_LDFLAGS}")
    elseif(CMAKE_SYSTEM_NAME MATCHES NintendoDS)
      add_definitions(-DARM9 -D__NDS__ -DNEED_READV -DHAVE_SOCKADDR_STORAGE -DNEED_WRITEV -DNEED_GETLOGIN_R -DNEED_GETADDRINFO -DNEED_FREEADDRINFO -DNEED_POLL)
      set(CMAKE_C_FLAGS "-Wno-format -Wpointer-arith")      
      set(CMAKE_CXX_FLAGS "${CMAKE_C_FLAGS} -fno-rtti -fno-exceptions -std=gnu11")
      set(CMAKE_C_LDFLAGS "${CMAKE_C_FLAGS} -specs=ds_arm9.specs -g")
      add_compile_options("${CMAKE_C_FLAGS} ${CMAKE_LDFLAGS}")      
    elseif(CMAKE_SYSTEM_NAME MATCHES NintendoGameCube)      
      add_definitions(-DGEKKO -D__GC__ -DNEED_READV -DNEED_WRITEV -DNEED_GETLOGIN_R -DNEED_GETADDRINFO -DNEED_FREEADDRINFO -DNEED_POLL)
      set(CMAKE_C_FLAGS "-g")
      #-O3 -Wall      
      add_compile_options("${CMAKE_C_FLAGS}")    
    elseif(CMAKE_SYSTEM_NAME MATCHES NintendoWii)
      add_definitions(-DGEKKO -D__WII__ -DNEED_READV -DNEED_WRITEV -DNEED_GETLOGIN_R -DNEED_GETADDRINFO -DNEED_FREEADDRINFO -DNEED_POLL)
      set(CMAKE_C_FLAGS "-g")
      #-O3 -Wall      
      add_compile_options("${CMAKE_C_FLAGS}")
    elseif(CMAKE_SYSTEM_NAME MATCHES CafeOS)
      add_definitions(-D__WIIU__ -DNEED_READV -DNEED_WRITEV -DNEED_GETLOGIN_R)
      set(CMAKE_C_FLAGS "-g")
      #-O3 -Wall      
      add_compile_options("${CMAKE_C_FLAGS}")    
    elseif(PS4)
      add_definitions(-DPS4_PLATFORM)
      set(CMAKE_C_FLAGS "-funwind-tables")
      #-fuse-init-array -emit-llvm broken...
      set(CMAKE_CXX_FLAGS "${CMAKE_C_FLAGS}")    
      add_compile_options("${CMAKE_C_FLAGS}")
    elseif(EE)
      add_definitions(-DNEED_BE64TOH -DNEED_POLL -DNEED_WRITEV -DNEED_READV -DNEED_GETLOGIN_R)
      if(EE AND PS2RPC)
        add_definitions(-DPS2RPC)
      endif()      
    elseif(IOP)
      add_definitions(-DHAVE_CONFIG_H -DNEED_BE64TOH -DNEED_STRDUP -DNEED_READV -DNEED_WRITEV -DNEED_POLL -DNEED_GETPID -DNEED_RANDOM -DNEED_SRANDOM -DNEED_GETLOGIN_R -DHAVE_STRING_H -DHAVE_SYS_FCNTL_H)
      if(IOP AND BUILD_IRX)
        add_definitions(-D__ps2sdk_iop__)
        if(DEBUG)
          add_definitions(-DDEBUG)
        endif()
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -fno-builtin")
        set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -s")                
      endif()
      set(CMAKE_C_FLAGS "-Wall") 
      include_directories(${CMAKE_CURRENT_BINARY_DIR} include/ps2)
      add_compile_options("${CMAKE_C_FLAGS}")
    elseif(VITA)
      add_definitions(-DNEED_READV -DNEED_WRITEV -DNEED_GETLOGIN_R)  
    elseif(PICO_BOARD)
      add_definitions(-DNEED_BE64TOH -DNEED_POLL -DNEED_GETLOGIN_R)
    elseif(ESP_PLATFORM)    
      if(NOT CMAKE_BUILD_EARLY_EXPANSION)
        add_definitions(-DHAVE_CONFIG_H)
      endif()
      add_definitions(-DNEED_READV -DNEED_WRITEV -DNEED_GETLOGIN_R -DNEED_RANDOM -DNEED_SRANDOM)    
    elseif(CMAKE_SYSTEM_NAME MATCHES Dreamcast)
      add_definitions(-DNEED_WRITEV -DNEED_READV -DHAVE_CONFIG_H -DNEED_GETLOGIN_R)             
    elseif(CMAKE_SYSTEM_NAME STREQUAL Solaris)
      find_library(SOCKET_LIBRARY socket)
      find_library(NSL_LIBRARY nsl)
      list(APPEND CORE_LIBRARIES ${SOCKET_LIBRARY} ${NSL_LIBRARY})
    endif()


    if(ENABLE_EXAMPLES)
      add_subdirectory(examples)
    endif()

    add_subdirectory(lib)

  if(NOT PICO_BOARD OR ESP_PLATFORM)
      include(CMakePackageConfigHelpers)
      write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/libsmb2-config-version.cmake
                                    VERSION ${PROJECT_VERSION}
                                    COMPATIBILITY AnyNewerVersion)
    if(NOT IOP AND NOT BUILD_IRX)
      configure_file(cmake/libsmb2.pc.cmake
                  ${CMAKE_CURRENT_BINARY_DIR}/libsmb2.pc @ONLY)

      install(DIRECTORY include/smb2
            DESTINATION ${INSTALL_INC_DIR})

      install(FILES cmake/FindSMB2.cmake
                  ${CMAKE_CURRENT_BINARY_DIR}/libsmb2-config-version.cmake
            DESTINATION ${INSTALL_CMAKE_DIR})

      install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libsmb2.pc
            DESTINATION ${INSTALL_PKGCONFIG_DIR})
    endif()
  endif()

=== examples/CMakeLists.txt ===
list(APPEND CORE_LIBRARIES ${POPT_LIBRARY})

set(SOURCES smb2-cat-async
            smb2-cat-sync
            smb2-ftruncate-sync
            smb2-ls-async
            smb2-put-async
            smb2-put-sync
            smb2-raw-stat-async
            smb2-raw-getsd-async
            smb2-readlink
            smb2-lsa-lookupsids
            smb2-lseek-sync
            smb2-share-enum
            smb2-share-info
            smb2-stat-sync
            smb2-truncate-sync
            smb2-CMD-FIND
            smb2-server-sync)

foreach(TARGET ${SOURCES})
  add_executable(${TARGET} ${TARGET}.c)
  target_link_libraries(${TARGET} smb2 ${CORE_LIBRARIES})
  add_dependencies(${TARGET} smb2)
endforeach()

add_definitions(-Werror "-D_U_=__attribute__((unused))")

=== debian/changelog ===
libsmb2 (6.2+dfsg-2+deb13u1) trixie; urgency=medium

  * Import upstream patches to fix CVE-2025-57632
    - When processing SMB2 chained PDUs (NextCommand), libsmb2
      repeatedly calls smb2_add_iovector() to append to a
      fixed-size iovec array without checking the upper bound
      of v->niov (SMB2_MAX_VECTORS=256)
  * d/p/CVE-2025-57632-pt*.patch: Import upstream patches to fix CVE
  * d/p/CVE-2025-57632-pt2.patch: Backport patch and Update hunks' offsets
  * d/p/CVE-2025-57632-pt3.patch: Backport patch and Update hunks' offsets
  * d/p/CVE-2025-57632-pt4.patch: Backport patch and Change hunk to
    reflect new code indentation

 -- Matheus Polkorny <mpolkorny@gmail.com>  Fri, 17 Oct 2025 20:26:34 -0300

libsmb2 (6.2+dfsg-2) unstable; urgency=medium

  * d/control: Bump Standards-Version to 4.7.2 (no changes)
  * d/copyright:
    - Bump copyright year in debian/*
    - Remove physical address from fsf license
  * d/patches:
    - 10-Fix-compiler-warning.patch: New Upstream patch
    - 20-Handle-a-bunch-of-other-compiler-warnings.patch: New Upstream patch

 -- Matheus Polkorny <mpolkorny@gmail.com>  Thu, 03 Apr 2025 15:20:58 -0300

libsmb2 (6.2+dfsg-1) unstable; urgency=medium

  * New upstream version 6.2+dfsg
    - Remove /lib/ps2/irx_imports.h due to license incompatibility
  * d/copyright:
    - Add lib/ps2/irx_imports.h to Files-Excluded
    - Change license name from MIT to Expat
  * d/watch: Update to dfsg and use github api

 -- Matheus Polkorny <mpolkorny@gmail.com>  Wed, 19 Mar 2025 11:04:47 -0300

libsmb2 (6.2-1) unstable; urgency=medium

  * Initial release. (Closes: #1068113)
  * New upstream version 6.2

 -- Matheus Polkorny <mpolkorny@gmail.com>  Thu, 26 Dec 2024 12:15:24 -0300

=== debian/control ===
Source: libsmb2
Section: libs
Priority: optional
Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders: Matheus Polkorny <mpolkorny@gmail.com>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libkrb5-dev,
Standards-Version: 4.7.2
Homepage: https://github.com/sahlberg/libsmb2
Vcs-Browser: https://salsa.debian.org/pkg-security-team/libsmb2
Vcs-Git: https://salsa.debian.org/pkg-security-team/libsmb2.git

Package: libsmb2-6
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: Libsmb2 is a SMB2/3 client library (library)
 for accessing or serving SMB2/SMB3 shares on a network.
 It is high performance and fully async. It supports both zero-copy
 for SMB READ/WRITE commands as well as compounded commands.
 .
 This package contains the shared library.

Package: libsmb2-dev
Section: libdevel
Architecture: any
Depends:
 libsmb2-6 (= ${binary:Version}),
 ${misc:Depends},
Description: Libsmb2 is a SMB2/3 client library (development)
 for accessing or serving SMB2/SMB3 shares on a network.
 It is high performance and fully async. It supports both zero-copy
 for SMB READ/WRITE commands as well as compounded commands.
 .
 This package contains the development files.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

execute_after_dh_install:
	rm -f debian/tmp/usr/lib/*/*.la

# Skipping tests for now
# To run these tests, an SMB server must export a share, and two
# configuration files (/tests/NTLM and tests/setup.local) need to be created

override_dh_auto_test:
	echo "Skipping tests"

=== debian/watch ===
version=4
opts="searchmode=plain, \
      filenamemangle=s%v?@ANY_VERSION@%@PACKAGE@-$1.tar.xz%, \
      dversionmangle=s/@DEB_EXT@//, \
      repacksuffix=+dfsg" \
https://api.github.com/repos/sahlberg/libsmb2/tags?per_page=100 \
https://api.github.com/repos/[^/]+/[^/]+/tarball/refs/tags/@PACKAGE@?@ANY_VERSION@
